﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Net;
using System.Threading;
using Microsoft.WindowsAzure;
using Microsoft.WindowsAzure.Diagnostics;
using Microsoft.WindowsAzure.ServiceRuntime;
using Microsoft.WindowsAzure.StorageClient;

namespace WorkerRole1
{
    public class WorkerRole : RoleEntryPoint
    {
        public override void Run()
        {
            // This is a sample worker implementation. Replace with your logic.
            Trace.WriteLine("WorkerRole1 entry point called", "Information");

            while (true)
            {
                Thread.Sleep(10000);
                Trace.WriteLine("Working", "Information");
            }
        }

        public CloudStorageAccount StorageAccount = default(CloudStorageAccount);
        public override bool OnStart()
        {
            // Set the maximum number of concurrent connections 
            ServicePointManager.DefaultConnectionLimit = 12;

            DiagnosticMonitor.Start("DiagnosticsConnectionString");

            // For information on handling configuration changes
            // see the MSDN topic at http://go.microsoft.com/fwlink/?LinkId=166357.
            RoleEnvironment.Changing += RoleEnvironmentChanging;

            //StorageAccount = new CloudStorageAccount(new StorageCredentialsAccountAndKey("footlocker",
            //            "M9E2FVgXYF9x8UEkvTRTcERKcaF3QXpuJJdTKAH+l2pZQ7I66ZdJsRDyh//972pprDybSmgYXBQTQHZlt7b2nQ==")
            //            , new Uri(@"http://footlocker.blob.core.windows.net/")
            //            , new Uri(@"http://footlocker.queue.core.windows.net/")
            //            , new Uri(@"http://footlocker.table.core.windows.net/"));

            StorageAccount = CloudStorageAccount.FromConfigurationSetting("CloudStorage");

            //CreateAuthorTable();
            AddEntities();
            SelectEntities();
            return base.OnStart();
        }

        private void RoleEnvironmentChanging(object sender, RoleEnvironmentChangingEventArgs e)
        {
            // If a configuration setting is changing
            if (e.Changes.Any(change => change is RoleEnvironmentConfigurationSettingChange))
            {
                // Set e.Cancel to true to restart this role instance
                e.Cancel = true;
            }
        }

        public void CreateAuthorTable()
        {
            
            //CloudStorageAccount StorageAccount = new CloudStorageAccount(new StorageCredentialsAccountAndKey("devstoreaccount1",
            //    "Eby8vdM02xNOcqFlqUwJPLlmEtlCDXJ1OUzFT50uSRZ6IFsuFq2UVErCz4I6tq/K1SZFPTOtr/KBHBeksoGMGw==")
            //    , new Uri(@"http://127.0.0.1:10000/ ")
            //    , new Uri(@"http://127.0.0.1:10001/ ")
            //    , new Uri(@"http://127.0.0.1:10002/ "));

            var TableClient = StorageAccount.CreateCloudTableClient();

            IEnumerable<string> tableList = TableClient.ListTables();
            foreach (string tableName in tableList)
            {
                Debug.WriteLine(tableName);
            }
            TableClient.CreateTableIfNotExist("Authors");

        }

        public void AddEntities()
        {
            var TableClient = StorageAccount.CreateCloudTableClient();

            TableStorageAuthor author = new TableStorageAuthor();
            author.FirstName = "Joseph";
            author.LastName = "Fultz";
            author.RowKey = System.Guid.NewGuid().ToString();
            author.Id = author.RowKey;
            author.State = "TX";
            author.PartitionKey = "TX";

            AuthorDataServiceContext ctx = new AuthorDataServiceContext(StorageAccount.TableEndpoint, StorageAccount.Credentials);
            ctx.Add(author);
        }

        public void SelectEntities()
        {
            AuthorDataServiceContext ctx = new AuthorDataServiceContext(StorageAccount.TableEndpoint, StorageAccount.Credentials);

            var authors = from a in ctx.AuthorData
                          select a;

            foreach (TableStorageAuthor ta in authors)
            {
                Debug.WriteLine(ta.FirstName + " " + ta.LastName);
            }
        }
    }
}
